/*
  Copyright (C) 2024-2025  Selwin van Dijk

  This file is part of signalbackup-tools.

  signalbackup-tools is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  signalbackup-tools is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with signalbackup-tools.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "signalbackup.ih"

std::string SignalBackup::getTranslatedName(std::string const &table, std::string const &old_column_name) const
{
  if (auto it = s_columnaliases.find(table); it != s_columnaliases.end())
    for (auto const &v : it->second)
      if (bepaald::contains(v, old_column_name))
        for (auto const &col_name : v)
          if (d_database.tableContainsColumn(table, col_name))
          {
            //Logger::message("TRANSLATING COLUMN NAME: ", old_column_name, " -> ", col_name);
            return col_name;
          }
  return std::string();
}
