/*
  Copyright (C) 2021-2024  Selwin van Dijk

  This file is part of signalbackup-tools.

  signalbackup-tools is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  signalbackup-tools is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with signalbackup-tools.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "signalbackup.ih"

// called on source!
void SignalBackup::remapRecipients()
{

  // CALLED ON SOURCE
  Logger::message(" Remapping recipients! ");

  SqliteDB::QueryResults results;
  d_database.exec("SELECT * FROM remapped_recipients", &results);

  for (unsigned int i = 0; i < results.rows(); ++i)
  {
    updateRecipientId(results.getValueAs<long long int>(i, "new_id"),
                      results.getValueAs<long long int>(i, "old_id"));
  }

}
